/****************************************************************
 OasisEdgeFactory.C
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#include "OasisEdgeFactory.H"
#include <iostream>
#include "OasisEdge.H"
#include "tigrscan/Signal.H"
#include "tigrscan/SignalTypeProperties.H"

/*
  Overloaded method.  Returns a special 'PhasedOasisEdge'.
 */
PhasedEdge *OasisEdgeFactory::newPhasedEdge(double scorePhase0,double scorePhase1,
					    double scorePhase2,
					    Signal *left,Signal *right)
{
  SignalType leftSignalType=left->getSignalType();
  SignalType rightSignalType=right->getSignalType();
  ContentType contentType=
    SignalTypeProperties::global.getContentType(leftSignalType,
						rightSignalType);
  return isCoding(contentType) ?
    new PhasedOasisEdge(scorePhase0,scorePhase1,scorePhase2,left,right) :
    new PhasedEdge(scorePhase0,scorePhase1,scorePhase2,left,right);
  
}



