/****************************************************************
 PromerSignalMap.H
 bmajoros@tigr.org

 Copyright (c)2003, The Institute for Genomic Research (TIGR),
 Rockville, Maryland, U.S.A.  All rights reserved.  This software
 is governed by the ARTISTIC LICENSE (see www.opensource.org).
 ****************************************************************/
#ifndef INCL_PromerSignalMap_H
#define INCL_PromerSignalMap_H
#include "tigr++/TigrSet.H"
#include "PromerParser.H"
#include "tigrscan/ParseGraph.H"

/****************************************************************
 PromerSignalMap maps signals in the query genome to signals 
 in the reference genome.
 ****************************************************************/

class PromerSignalMap
{
  ParseGraph &qGraph;
  PromerCoordMap &M;
  int exactMatchTolerance, nonexactMatchTolerance; // both in bp
  int numVertices;
  bool constrainNonexactMatches;

  int findSignals(int begin,int end,TigrSet<SignalPtr> &,SignalType);
public:
  PromerSignalMap(ParseGraph &referenceSequenceGraph,
		  PromerCoordMap &,int exactMatchTolerance,
		  int nonexactMatchTolerance,bool constrainNonexactMatches);
  TigrSet<SignalPtr> *mapSignal(Signal &querySignal,bool &withinMatch);
  bool mapSignal(Signal &querySignal,
		 TigrSet<SignalPtr> &referenceSequenceSignals);
  int rowNearReferenceCoord(int referenceCoord);
};


#endif
